<template>

	<div class="container-fluid offer-ride">

            <loading :active.sync="isLoading"
                 :can-cancel="true"
                 :is-full-page="fullPage">
            </loading>
        <flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>

        <div class="container" v-if="!successRequest">
            <div class="row">
                <h2> Join Ride </h2> 
                
                <div class="col-md-7 form-group" v-if="ride">

					<h3>{{ ride['location_from'] }} &#8594; {{ ride['location_to'] }}</h3>

					<span class="add-id">Date Range:</span><br>
                    <span><strong>From: </strong> {{(ride['open_date_from']) }} <br> 
					 <strong> To:</strong> {{(ride['open_date_to']) }} </span>

                     <div class="hours" v-if="options">
                        <span class="add-id"><strong> Hours Available:</strong></span> 
                        <label class="badge badge-success" v-for="time in Availablehours">
                            {{ time.hour | formatTime }}
                        </label>
                     </div>
                    <p><strong>Trip Purpose:</strong> {{ride.purpose}}</p>
                    <div class="row">
                        <div class="user-dashboard-profile">
                            <!--<li class="list-group-item" style="background-color: #eee;">-->
                            <div>
                                <div class="col-md-5 bordered-box right-margin">
                                    <h3 class="heading-underline">Driver</h3>
                                    <div class="profile-thumb profile-thumb-joinride">
                                        <img :src="user.avatar" width="85px" height="85px" class="img-circle" alt="ridesurf driver">
                                    </div>

                                    <!-- User Name -->
                                    <p>{{ user.first_name }}
                                        {{ user.last_name }}</p>

                                    <div class="stars">
                                        <span v-for="item in user.rating" class="fa fa-star checked"></span>
                                        <span v-for="item in (5 - user.rating)" class="fa fa-star"></span>
                                    </div>

                                    <p><strong>Active Since:</strong> {{  user.joined  }}<br />
                                        <strong>Gender:</strong> {{ user.gender }}</p>
                                    <a v-bind:href=" 'rides/viewUserProfile/' + user.id"
                                       class="btn btn-info">View Public Profile</a>
                                </div>
                            </div>
                            <div class="col-md-5 bordered-box">

                                <h3 class="heading-underline">Vehicle</h3>

                                <img :src="vehicle.path_image" width="100px" height="100px" class="img-circle bottom-margin">

                                <p>
                                    <strong>Make:</strong> {{ vehicle.make }}<br />
                                    <strong>Model:</strong> {{ vehicle.model }} <br />
                                    <strong>Color:</strong> {{ vehicle.color }} <br />
                                    <strong>Year:</strong> {{ vehicle.year }} <br />
                                    <strong>Type:</strong> {{ vehicle.type}}
                                </p>

                            </div>
                        </div>
                    </div>
				</div>

                <div class="col-md-5 text-center">
                    <div class="widget" style="height: auto;">
                        <div class="col-md-4 mobile-split-50" style="border-right: solid 1px  rgba(0, 0, 0, 0.1)">
                            <h4 class="add-id"><strong>Price </strong></h4>
                            <span style="color:green;font-size: 3em"> ${{ ride['price'] }}</span>
                        </div>
                        <div class="col-md-8 mobile-split-50" style="">
                            <h4>Seats Available </h4>
                            <span style="font-size: 3em">{{ ride['seats'] }}</span>
                        </div>
                    </div>

                    <div class="container-fluid">
                        <div class="row" style="margin-bottom: 25px;">
                            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                <h3 style="margin-top: 25px"> How many Seats you will need? </h3>
                                <integer-plusminus :min="1"
                                                   :max="ride['seats']"
                                                   :step="1"
                                                   :vertical="false"
                                                   v-model="seats">
                                    
                                    {{ seats }}

                                    <template slot="decrement">-</template>

                                    <template slot="increment">+</template>
                                </integer-plusminus>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                <h3 style="margin-top: 25px"> Which date works for you? </h3>
                                <select v-model="dateRequest" name="date" class="form-control" style="margin-bottom: 15px;" >
                                    <option v-bind:value="item"
                                            v-for="item in datesArray">
                                        {{item}} </option>
                                </select>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                <h3 style="margin-top: 25px"> Which hour works for you? </h3>
                                <select v-model="requestHour" name="hour" class="form-control" style="margin-bottom: 15px;" >
                                    <option v-bind:value="hour.time"
                                            v-for="(hour) in options"> {{hour.time | formatTime}}</option>
                                </select>
                            </div>
                    </div>
                        <div v-if="join">
                            <button v-on:click="requestToJoin" class="btn btn-primary">Request to Join</button>
                        </div>

                </div>
            </div>

            </div> 
        </div> <!-- Request Container -->
        <div class="container" v-if="successRequest">
            <SuccessRequest></SuccessRequest>
        </div> <!-- Success Container -->
    </div>
</template>

<script>
    import {IntegerPlusminus} from 'vue-integer-plusminus';
    import axios from 'axios';
    import Multiselect from 'vue-multiselect';
    import moment from 'moment';
    import SuccessRequest from "./SuccessRequest";
    import Loading from 'vue-loading-overlay';

    export default {

    	name: "joinride",
        props:['openride', 'hour', 'dates', 'currentuser', 'auto', 'join', 'user'],
        components:{ IntegerPlusminus,axios, Multiselect , moment, SuccessRequest, Loading},
        mounted(){
            for(var i=0; i < this.Availablehours.length; i++ ){
                this.options.push({ 'time': moment(String(this.Availablehours[i].hour), "h:mm:ss ").format('hh:mm a')  });
            }
            this.requestHour =  moment(String(this.Availablehours[0].hour), "h:mm:ss ").format('hh:mm a');
            this.dateRequest = this.datesArray[0];
            console.log(this.vehicle);

            if(this.currentuser.avatar == null || this.currentuser.verified == 0 || this.currentuser.address == null ){
                this.join == false;
            }
        },

        data(){
            return{

               ride: this.openride,
               Availablehours: this.hour,
               vehicle:this.auto,
               datesArray:this.dates,
               seats:1,
               options:[],
               optionDate:[],
               requestHour:'',
               dateRequest:'',
               errorMessage:'',
               displayMessage:false,
               successRequest:false,
               isLoading :false,
               fullPage:false,
            }
        },
        created(){

        },
        methods:{
            requestToJoin: function(){

                isLoading = true;
                if(this.join == false){
                     this.flash("You can't join this ride because your account is missing information", 'error')
                    return false;
                }
                axios.post('/rides/openRide/join/' + this.ride.id, {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'hour':this.requestHour,
                        'date':this.dateRequest,
                        'seats':this.seats,

                    }
                }).then(response => {
                    this.isLoading = false;
                    this.successRequest = true;

                }).catch(e => {
                    this.isLoading = false;
                    this.errors.push(e)
                })
            }

        }

    }
</script>